<?php
/*-----------------------------------------------------------------------------
                     ADMIN UPLOAD UTILITY - A phpBB Add-On
  ----------------------------------------------------------------------------
    Please read the file README.TXT for licensing and copyright information.
  ----------------------------------------------------------------------------
    admin_upload.php - Main File
    Version: 2.4.2
    Begun: August 19, 2003
    Last Modified: Sunday, May 29, 2005
-----------------------------------------------------------------------------*/

define('IN_PHPBB', 1);

// Set basic paths.
$phpbb_adm_path = './';                // Might be useful for Nuke porters?
$phpbb_root_path = $phpbb_adm_path . '../';
define('AUU_PATH', $phpbb_root_path . 'mods/uploader/');
define('AUU_ALL', 'all');			// Name of "list all modules" type
define('SHOW_ALL_NAV', FALSE);		// Show all links in admin navigation frame

// Pull php extension if not already done.
require_once($phpbb_root_path . 'extension.inc');

if( !empty($setmodules) )
{
	$filename = basename(__FILE__);
	$module['General']['Get_Upload'] = $filename . '?type=' . AUU_ALL;
	if( SHOW_ALL_NAV )
	{
		$modules_dir = @opendir(AUU_PATH);
		while( $module_file = @readdir($modules_dir) )
		{
			if( preg_match('/^module_(.*?)\.' . $phpEx . '$/', $module_file) )
			{
				include_once(AUU_PATH . $module_file);
			}
		}

		@closedir($modules_dir);
	}
	return;
}

// Check for required version of PHP.
if( phpversion() < '4.1.0' )
{
	die('Sorry, but this add-on requires PHP version 4.1.0 or later to operate. An older version seems to be installed on your server. Talk to your webhost about upgrading their PHP installation.');
}

// Set php extension into a constant, with a period prepended.
define('PHPEX', '.' . $phpEx);
// We will use the constant PHPEX instead of $phpEx from this point onward.

// Kick the tires and light the fires
require_once($phpbb_adm_path . 'pagestart' . PHPEX);
require_once(AUU_PATH . 'class_auu' . PHPEX);

// Initalizing stuff.
$auu = $upload = $gen = '';

// Load necessary module files: language, config, functions.
$auu = new AUU_Config();

$auu->get_config_file($auu->options['module_name']);

$auu->set_module_name( (($auu->options['module_name'] == AUU_ALL) ? AUU_ALL: $auu->cfg['internal_name']) );

$gen = new AUU_General($auu);
$gen->get_lang_files();


// Check to see if server allows PHP uploads.
$upload_var = (bool) @ini_get('file_uploads');
$form_enctype = ( !$upload_var ) ? '' : 'enctype="multipart/form-data"';

// Define this one time here... it's used in three places, so this is easier.
$template->set_filenames(array('error' => 'error_body.tpl'));
if( !empty($form_enctype) )
{
	$template->assign_block_vars('switch_uploads', array());
}
else
{
	$template->assign_vars(array('ERROR_MESSAGE' => $lang['UPGEN_SORRY']));
	$template->assign_var_from_handle('NO_UPLOADS', 'error');
}

if( $auu->module == AUU_ALL )
{
	// List all installed modules
	$template->set_filenames(array(
		'body' => 'admin/uploader_list.html')
	);
	
	$template->assign_vars(array(
		'L_UPLOADS_TITLE' => $lang['UPGEN_WELCOME'],
		'L_UPLOADS_TEXT' => $lang['UPGEN_EXPLAIN']
	));

	if( !$auu->loaded )
	{
		$template->assign_vars(array('ERROR_MESSAGE' => $lang['UPGEN_NO_MODULES']));
		$template->assign_var_from_handle('NO_MODULES', 'error');
	}
	else
	{
		$filename = basename(__FILE__);
		foreach($auu->cfg as $k=>$module)
		{
			$template->assign_block_vars('modules', array(
				'U_MODULE' => $phpbb_adm_path . $filename . '?type=' . $module['internal_name'] . '&amp;sid=' . $userdata['session_id'],
				'NAME' => sprintf($lang['UPGEN_MODULE'], $module['display_name']),
				'MANAGES' => sprintf($lang['UPGEN_MANAGES'], $module['object_name'], $module['object_type_display'])
			));
		}
	}
}
else
{
	$upload = new AUU_Uploader();

	// Load module functions file.
	require_once(AUU_PATH . 'module_' . $auu->module . PHPEX);

	// Begin main processing.
	if ( isset($_POST['submit']) )
	{
		if( $auu->options['mode'] == 'upload' )
		{
			if( !is_null($upload->run_preprocessor()) )
			{
				if( $upload->upload_object() && $auu->options['auto_add'] )
				{
					$upload->add_database_entry();
					$upload->run_postprocessor();
				}
			}
		}
		// Deletion code follows.
		elseif( $auu->options['mode'] == 'delete' && $auu->options['delete'] )
		{
			foreach($auu->options['delete'] as $k=>$v)
			{
				if( $auu->cfg['tpl'] )
				{
					// template dependent
					$templates = $gen->get_templates_list();
					if( $auu->options['delete_all'] )
					{
						// delete in all templates
						foreach($templates as $plate)
						{
							$upload->deleter( $gen->build_tpl_path($auu->cfg['file_path'], $plate), $v);
						}
					}
					else
					{
						// delete in just the one
						if( in_array($auu->options['del_tpls'][$k], $templates) )
						{
							$upload->deleter($gen->build_tpl_path($auu->cfg['file_path'], $auu->options['del_tpls'][$k]), $v);
						}
						else
						{
							$gen->build_error_msg('UPGEN_TEMPLATE_NF_1', $auu->options['del_tpls'][$k]);
						}
					}
				}
				else
				{
					$upload->deleter($auu->cfg['file_path'], $v);
				}
			} //foreach
		} // mode delete
	}

	// Do you have a problem?
	if ( !empty($gen->error_msg) )
	{
		$template->assign_vars(array('ERROR_MESSAGE' => $gen->error_msg));
		$template->assign_var_from_handle('ERROR_BOX', 'error');
	}

	// Begin building the main part of the page. Header was done way up top.
	$template->set_filenames(array(
		'body' => 'admin/uploader_body.html')
	);

	$s_hidden_fields = '<input type="hidden" name="type" value="' . $auu->module . '" />';
	$s_hidden_fields1 = $s_hidden_fields . '<input type="hidden" name="mode" value="upload" />';
	$s_hidden_fields2 = $s_hidden_fields . '<input type="hidden" name="mode" value="delete" />';

	$template->assign_vars(array(
		'UPLOADER_PATH' => AUU_PATH,
		'MAX_FILE_SIZE' => $auu->cfg['max_filesize'],
		'COL_NUMBER' => $auu->cfg['table_columns'],

		'L_SUBMIT' => $lang['Submit'],
		'L_RESET' => $lang['Reset'],
		'L_UNMARK_ALL' => $lang['Unmark_all'],
		'L_MARK_ALL' => $lang['Mark_all'],
		'L_DELETE_MARKED' => $lang['Delete_marked'],
		'L_DELETE_DB' => $lang['UPGEN_DELETE_DB'],

		'L_UPLOAD' => sprintf($lang['AUUMODULE_UPLOAD'], $auu->cfg['display_name']),
		'L_UPLOAD_EXPLAIN' => sprintf($lang['AUUMODULE_UPLOAD_EXPLAIN'], $auu->cfg['object_name']) . sprintf($lang['UPGEN_UPLOAD_EXPLAIN'], $auu->cfg['max_filesize_kb'], $auu->cfg['max_width'], $auu->cfg['max_height']),
		'L_UPLOAD_FILE' => $lang['UPGEN_FILE'],
		'L_UPLOAD_NAME' => $lang['UPGEN_UPLOAD_NAME'],
		'L_DEFAULT_NAME' => $lang['UPGEN_DEFAULT_NAME'],
		'L_NAME_EXPLAIN' => $lang['UPGEN_NAME_EXPLAIN'],
		'L_UPLOADED' => sprintf($lang['AUUMODULE_UPLOADED'], $auu->cfg['object_name'], $auu->cfg['object_type_display']),
		'L_AUTO_ADD' => sprintf($lang['AUUMODULE_AUTO_ADD'], $auu->cfg['display_name']),
		'S_HIDDEN_FIELDS' => $s_hidden_fields1,
		'S_HIDDEN_DELETE' => $s_hidden_fields2,
		'S_FORM_ENCTYPE' => $form_enctype,
		'S_PROFILE_ACTION' => 'admin_upload' . PHPEX . '?sid=' . $userdata['session_id']
	));

	if( $auu->cfg['tpl'] )
	{
		$template->assign_block_vars('tpl', array(
			'L_DELETE_ALL' => $lang['UPGEN_DELETE_ALL'],
		));

		// Need to use an if statement here to prevent switch_uploads.tpl from
		// displaying a hidden switch_uploads if uploads are turned off.
		if( !empty($form_enctype) )
		{
			$templates = $gen->get_templates_list();
			$tpl_select = '<select name="style">';
			foreach($templates as $val)
			{
				$tpl_select .= '<option value="' . $val . '">' . $val . '</option>';
			}
			$tpl_select .= '</select>';
			$template->assign_block_vars('switch_uploads.tpl', array(
				'L_CHOOSE_TPL' => $lang['UPGEN_CHOOSE_TPL'],
				'L_TPL_EXPLAIN' => $lang['UPGEN_TPL_EXPLAIN'],
				'S_TPL' => $tpl_select
			));
		}
	}

	// Pull any module specific tpl code.
	$gen->run_module_function('assign_module_tpl');

	// Display uploaded files.
	$gen->display_files($auu->cfg);

	if( function_exists('delete_db_object') && $gen->files_present )
	{
		$template->assign_block_vars('delete_db', array());
	}

	if( $auu->cfg['db'] )
	{
		$template->assign_block_vars('switch_uploads.autoadd', array());
	}
}

$template->pparse('body');

include($phpbb_adm_path . 'page_footer_admin' . PHPEX);
// I didn't hear no fat lady!!
?>