<?php
/***************************************************************************
 *                            admin_version.php
 *                            -------------------
 *   begin                : April 8, 2005
 *   author               : Fountain of Apples < webmacster87@gmail.com >
 *   author               : DemonBob < dustin.coates@systemoverload.net >
 *
 *   Revision: 1.2.0 -- 11/10/2005
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

//
// Let the ACP know this file exists
//
define('IN_PHPBB', 1); 

if( !empty($setmodules) ) 
{ 
    $file = basename(__FILE__); 
    $module['AVC_AVersioncheck']['Get_Important'] = $file;
    return; 
}

// 
// Load the default header 
// 
$no_page_header = FALSE; 
$phpbb_root_path = './../'; 
require($phpbb_root_path . 'extension.inc'); 
require('./pagestart.' . $phpEx);
// Some AVC specific includes
include($phpbb_root_path . 'includes/functions_avc.' . $phpEx);
include($phpbb_root_path . 'includes/constants_avc.' . $phpEx);
include($phpbb_root_path . 'language/lang_' . $board_config['default_lang'] . '/lang_avc.' . $phpEx);

// 
// Check for the userlevel
// 
if( !$userdata['session_logged_in'] ) 
{ 
    redirect(append_sid("login.$phpEx?redirect=admin/admin_tag.$phpEx", true)); 
} 

if( $userdata['user_level'] != ADMIN ) { message_die(GENERAL_MESSAGE, $lang['Not_Authorised']); } 

//
// Let's get this party started!
//
if ( isset($HTTP_POST_VARS['mode']) || isset($HTTP_GET_VARS['mode']) )
{
	$mode = ( isset($HTTP_POST_VARS['mode']) ) ? $HTTP_POST_VARS['mode'] : $HTTP_GET_VARS['mode'];
	$mode = htmlspecialchars($mode);
}
else
{
	$mode = '';
}

if ( isset($HTTP_POST_VARS['vid']) || isset($HTTP_GET_VARS['vid']) )
{
	$vid = ( isset($HTTP_POST_VARS['vid']) ) ? $HTTP_POST_VARS['vid'] : $HTTP_GET_VARS['vid'];
	$vid = intval($vid);
}
else
{
	$vid = '';
}

	
$template->set_filenames(array(
	"body" => "admin/version_body.tpl")
);

//
// Let's retrieve everything from the version check table for our use
//
$sql = "SELECT mod_id, mod_name, mod_status, mod_current_version, mod_time_stamp, mod_file_name, mod_domain_loc, mod_file_loc
				FROM " . VERSION_CHECK_TABLE . " WHERE mod_status = 1 AND mod_domain_loc != ''
				ORDER BY mod_id";
				
if( !$q_mod = $db->sql_query($sql) )
{
	message_die(GENERAL_ERROR, $lang['No_Version'], "", __LINE__, __FILE__, $sql);
}

if( $total_mods = $db->sql_numrows($q_mod) )
{
	$mod_rows = $db->sql_fetchrowset($q_mod);

	if(!$q_mod = $db->sql_query($sql))
	{
		message_die(GENERAL_ERROR, $lang['No_Version'], "", __LINE__, __FILE__, $sql);
	}
}

//
// First Version Check; perform the check if the time is right
//
for($i = 0; $i < $total_mods; $i++)
{
	$current_version = $mod_rows[$i]['mod_current_version'];
	$version = explode(".", $current_version);
	$head_revision = (int) $version[0];
	$minor_revision = (int) $version[2];
	$mod_domain_loc = $mod_rows[$i]['mod_domain_loc'];
	$mod_file_loc = $mod_rows[$i]['mod_file_loc'];
	$mod_file_name = $mod_rows[$i]['mod_file_name'];
	$mod_id = $mod_rows['mod_id'];

	$last_update_time = $mod_rows[$i]['mod_time_stamp'];
	$current_time = time();
	$time_elasped = $current_time - $last_update_time;

	if($time_elasped >= $version_config['check_time'])
	{
		$errno = 0;
		$errstr = $version_info = '';

		if ($fsock = @fsockopen($mod_domain_loc, 80, $errno, $errstr))
		{
			@fputs($fsock, "GET /$mod_file_loc/$mod_file_name HTTP/1.1\r\n");
			@fputs($fsock, "HOST: $mod_domain_loc\r\n");
			@fputs($fsock, "Connection: close\r\n\r\n");

			$get_info = false;
			while (!@feof($fsock))
			{
				if ($get_info)
				{
					$version_info .= @fread($fsock, 1024);
				    // Check to make sure this file is not an AVC 3 retrievable file -- added in 2.0.3
				    if ( !stristr($version_info, 'xml') === FALSE )
				    {
				        message_die(GENERAL_ERROR, $lang['AVC3_Retrievable'], '', __LINE__, __FILE__);
				    }
				    // End AVC 3 Check
				}
				else
				{
					if (@fgets($fsock, 1024) == "\r\n")
					{
						$get_info = true;
					}
				}
			}
			@fclose($fsock);

			$version_info = explode("\n", $version_info);
			$latest_head_revision = (int) $version_info[0];
			$latest_minor_revision = (int) $version_info[2];
			$latest_version = (int) $version_info[0] . '.' . (int) $version_info[1] . '.' . (int) $version_info[2];

			if ($latest_head_revision == $head_revision && $minor_revision == $latest_minor_revision)
			{
			$newsql = "UPDATE " . VERSION_CHECK_TABLE . "
					SET mod_time_stamp = '$current_time', mod_new_version = '$current_version'
					WHERE mod_id = " . $mod_rows[$i]['mod_id'] . "";

					if ( !$db->sql_query($newsql) )
					{
						message_die(GENERAL_ERROR, $lang['Status_no_Update'], '', __LINE__, __FILE__, $sql);
					}
			}
			else
			{
				$newsql = "UPDATE " . VERSION_CHECK_TABLE . "
				SET mod_time_stamp = '$current_time', mod_new_version = '$latest_version'
				WHERE mod_id = " . $mod_rows[$i]['mod_id'] . "";


			
				if ( !$db->sql_query($newsql) )
				{
					message_die(GENERAL_ERROR, $lang['Status_no_Update'], '', __LINE__, __FILE__, $sql);
				}
			}
			
//
// The checker isn't cooperating, so let's complain
//
		}
		else
		{
			if ($errstr)
			{
				message_die(GENERAL_ERROR, $lang['Connection_error'], '', __LINE__, __FILE__,$mod_rows[$i]['mod_name']);
			}
			else
			{
				message_die(GENERAL_ERROR, $lang['No_socket'], '', __LINE__, __FILE__, $newsql);
			}
		}
	}
}

//
// If the user doesn't want to wait for the auto-checks, let them recheck now
//
switch($mode)
{
	case $lang['btn_Submit']:
		
		$sql = "SELECT mod_id, mod_name, mod_status, mod_current_version, mod_time_stamp, mod_file_name, mod_domain_loc, mod_file_loc
				FROM " . VERSION_CHECK_TABLE . " WHERE mod_status = 1
				ORDER BY mod_id";
				
		if( !$q_mod = $db->sql_query($sql) )
		{
			message_die(GENERAL_ERROR, $lang['No_Version'], "", __LINE__, __FILE__, $sql);
		}

		if( $total_mods = $db->sql_numrows($q_mod) )
		{
			$mod_rows = $db->sql_fetchrowset($q_mod);

			if(!$q_mod = $db->sql_query($sql))
			{
				message_die(GENERAL_ERROR, $lang['No_Version'], "", __LINE__, __FILE__, $sql);
			}
		}

		for($i = 0; $i < $total_mods; $i++)
		{
			$current_version = $mod_rows[$i]['mod_current_version'];
			$version = explode(".", $current_version);
			$head_revision = (int) $version[0];
			$minor_revision = (int) $version[2];
			$mod_domain_loc = $mod_rows[$i]['mod_domain_loc'];
			$mod_file_loc = $mod_rows[$i]['mod_file_loc'];
			$mod_file_name = $mod_rows[$i]['mod_file_name'];
			$last_update_time = $mod_rows[$i]['mod_time_stamp'];
			$current_time = time();
			$time_elasped = $current_time - $last_update_time;
			$mod_id = $mod_rows['mod_id'];

			$errno = 0;
			$errstr = $version_info = '';

			if ($fsock = @fsockopen($mod_domain_loc, 80, $errno, $errstr))
			{
				@fputs($fsock, "GET /$mod_file_loc/$mod_file_name HTTP/1.1\r\n");
				@fputs($fsock, "HOST: $mod_domain_loc\r\n");
				@fputs($fsock, "Connection: close\r\n\r\n");

				$get_info = false;
			while (!@feof($fsock))
			{
				if ($get_info)
				{
					$version_info .= @fread($fsock, 1024);
				    // Check to make sure this file is not an AVC 3 retrievable file -- added in 2.0.3
				    if ( !stristr($version_info, 'xml') === FALSE )
				    {
				        message_die(GENERAL_ERROR, $lang['AVC3_Retrievable'], '', __LINE__, __FILE__);
				    }
				    // End AVC 3 Check
				}
				else
				{
					if (@fgets($fsock, 1024) == "\r\n")
					{
						$get_info = true;
					}
				}
			}
				@fclose($fsock);

				$version_info = explode("\n", $version_info);
				$latest_head_revision = (int) $version_info[0];
				$latest_minor_revision = (int) $version_info[2];
				$latest_version = (int) $version_info[0] . '.' . (int) $version_info[1] . '.' . (int) $version_info[2];

				if ($latest_head_revision == $head_revision && $minor_revision == $latest_minor_revision)
				{
					$newsql = "UPDATE " . VERSION_CHECK_TABLE . "
					SET mod_time_stamp = '$current_time', mod_new_version = '$current_version'
					WHERE mod_id = " . $mod_rows[$i]['mod_id'] . "";

					if ( !$db->sql_query($newsql) )
					{
						message_die(GENERAL_ERROR, $lang['Status_no_Update'], '', __LINE__, __FILE__, $sql);
					}
				}
				else
				{
					$newsql = "UPDATE " . VERSION_CHECK_TABLE . "
					SET mod_time_stamp = '$current_time', mod_new_version = '$latest_version'
					WHERE mod_id = " . $mod_rows[$i]['mod_id'] . "";

					if ( !$db->sql_query($newsql) )
					{
						message_die(GENERAL_ERROR, $lang['Status_no_Update'], '', __LINE__, __FILE__, $sql);
					}
				}
			}
			else
			{
				if ($errstr)
				{
					message_die(GENERAL_ERROR, $lang['Connection_error'], '', __LINE__, __FILE__,$mod_rows[$i]['mod_domain_loc']);
				}
				else
				{
					message_die(GENERAL_ERROR, $lang['No_socket'], '', __LINE__, __FILE__, $newsql);
				}
			}
		}
		$message = $lang['lbl_Status_Updated'] . "<br /><br />" . sprintf($lang['Click_return_version'], "<a href=\"" . append_sid("admin_version.$phpEx") . "\">", "</a>") . "<br /><br />" . sprintf($lang['Click_return_admin_index'], "<a href=\"" . append_sid("index.$phpEx?pane=right") . "\">", "</a>");

		message_die(GENERAL_MESSAGE, $message);
	break;
	
	case $lang['btn_Recheck_V'];
	
		$sql = "SELECT mod_id, mod_name, mod_status, mod_current_version, mod_time_stamp, mod_file_name, mod_domain_loc, mod_file_loc
				FROM " . VERSION_CHECK_TABLE . " WHERE mod_id = $vid
				ORDER BY mod_id";
				
		if( !$q_mod = $db->sql_query($sql) )
		{
			message_die(GENERAL_ERROR, $lang['No_Version'], "", __LINE__, __FILE__, $sql);
		}
			$mod_rows = $db->sql_fetchrow($q_mod);

			if(!$q_mod = $db->sql_query($sql))
			{
				message_die(GENERAL_ERROR, $lang['No_Version'], "", __LINE__, __FILE__, $sql);
			}
		
			$current_version = $mod_rows[$i]['mod_current_version'];
			$version = explode(".", $current_version);
			$head_revision = (int) $version[0];
			$minor_revision = (int) $version[2];
			$mod_domain_loc = $mod_rows['mod_domain_loc'];
			$mod_file_loc = $mod_rows['mod_file_loc'];
			$mod_file_name = $mod_rows['mod_file_name'];
			$last_update_time = $mod_rows['mod_time_stamp'];
			$current_time = time();
			$time_elasped = $current_time - $last_update_time;
			$mod_id = $mod_rows['mod_id'];

			$errno = 0;
			$errstr = $version_info = '';

			if ($fsock = @fsockopen($mod_domain_loc, 80, $errno, $errstr))
			{
				@fputs($fsock, "GET /$mod_file_loc/$mod_file_name HTTP/1.1\r\n");
				@fputs($fsock, "HOST: $mod_domain_loc\r\n");
				@fputs($fsock, "Connection: close\r\n\r\n");

				$get_info = false;
			while (!@feof($fsock))
			{
				if ($get_info)
				{
					$version_info .= @fread($fsock, 1024);
				    // Check to make sure this file is not an AVC 3 retrievable file -- added in 2.0.3
				    if ( !stristr($version_info, 'xml') === FALSE )
				    {
				        message_die(GENERAL_ERROR, $lang['AVC3_Retrievable'], '', __LINE__, __FILE__);
				    }
				    // End AVC 3 Check
				}
				else
				{
					if (@fgets($fsock, 1024) == "\r\n")
					{
						$get_info = true;
					}
				}
			}
				@fclose($fsock);

				$version_info = explode("\n", $version_info);
				$latest_head_revision = (int) $version_info[0];
				$latest_minor_revision = (int) $version_info[2];
				$latest_version = (int) $version_info[0] . '.' . (int) $version_info[1] . '.' . (int) $version_info[2];

				if ($latest_head_revision == $head_revision && $minor_revision == $latest_minor_revision)
				{
					$newsql = "UPDATE " . VERSION_CHECK_TABLE . "
					SET mod_time_stamp = '$current_time', mod_new_version = '$current_version'
					WHERE mod_id = " . $mod_rows['mod_id'] . "";

					if ( !$db->sql_query($newsql) )
					{
						message_die(GENERAL_ERROR, $lang['Status_no_Update'], '', __LINE__, __FILE__, $sql);
					}
				}
				else
				{
					$newsql = "UPDATE " . VERSION_CHECK_TABLE . "
					SET mod_time_stamp = '$current_time', mod_new_version = '$latest_version'
					WHERE mod_id = " . $mod_rows['mod_id'] . "";

					if ( !$db->sql_query($newsql) )
					{
						message_die(GENERAL_ERROR, $lang['Status_no_Update'], '', __LINE__, __FILE__, $sql);
					}
				}
			
//
// Don't you love to complain?
//
			}
			else
			{
				if ($errstr)
				{
					message_die(GENERAL_ERROR, $lang['Connection_error'], '', __LINE__, __FILE__,$mod_rows[$i]['mod_domain_loc']);
				}
				else
				{
					message_die(GENERAL_ERROR, $lang['No_socket'], '', __LINE__, __FILE__, $newsql);
				}
			}
		$message = $lang['lbl_Status_Updated'] . "<br /><br />" . sprintf($lang['Click_return_version'], "<a href=\"" . append_sid("admin_version.$phpEx") . "\">", "</a>") . "<br /><br />" . sprintf($lang['Click_return_admin_index'], "<a href=\"" . append_sid("index.$phpEx?pane=right") . "\">", "</a>");

		message_die(GENERAL_MESSAGE, $message);
	break; 
	
	default:
//
// Now we have some vars to assign
//
		$template->assign_vars(array(
			'L_VERSION_CHECK'	=> $lang['Version_check'],
			'L_VERSION_CHECK_EXPLAIN' => $lang['Version_check_explain'],
			'L_DOWNLOAD_MOD_HEADER' => $lang['lbl_Download_Mod'],
			'L_RECHECK_MOD_HEADER' => $lang['lbl_Recheck_Mod'],
			'L_MOD_NAME_HEADER' => $lang['lbl_Mod_Name'],
			'L_LATEST_VERSION_HEADER' => $lang['lbl_Latest_Version'],
			'L_CURRENT_VERSION_HEADER' => $lang['lbl_Current_Version'],

			'L_RECHECK_V_ALL' => $lang['btn_Recheck_V_All'])
		);

		$template->assign_block_vars('switch_version_check', array());
		$sql = "SELECT mod_id, mod_name, mod_current_version, mod_new_version, mod_file_loc, mod_topic_loc, mod_download_loc, mod_time_stamp
				FROM " . VERSION_CHECK_TABLE . " WHERE mod_status = 1
				ORDER BY mod_id";
	
		if( !$q_mod = $db->sql_query($sql) )
		{
			message_die(GENERAL_ERROR, $lang['No_Version'], "", __LINE__, __FILE__, $sql);
		}

		if( $total_mods = $db->sql_numrows($q_mod) )
		{
			$mod_rows = $db->sql_fetchrowset($q_mod);
	
			if(!$q_mod = $db->sql_query($sql))
			{
				message_die(GENERAL_ERROR, $lang['No_Version'], "", __LINE__, __FILE__, $sql);
			}
		}
	
		for($i=0;$i < $total_mods;$i++)
		{

			$mod_name = $mod_rows[$i]['mod_name'];
		
			$s_hidden_vid = '<input type="hidden" name="vid" value="'. $mod_rows[$i]['mod_id'] .'" />';
			
			if($mod_rows[$i]['mod_new_version'] > $mod_rows[$i]['mod_current_version'] )
			{
					$fcolor = 'color:red';
			}
			else
			{
					$fcolor = 'color:green';
			}

			$template->assign_block_vars('switch_version_check.switch_version_check_loop', array(
				
				'L_MOD_NAME' => $mod_rows[$i]['mod_name'],
				'U_TOPIC_LOC' => $mod_rows[$i]['mod_topic_loc'],
				'L_LAST_UPDATED' => $lang['lbl_Last_Updated'],
				'L_LAST_UPDATED_TIME' => create_date($board_config['default_dateformat'], $mod_rows[$i]['mod_time_stamp'], $board_config['board_timezone']),
				'L_DOWNLOAD_MOD' => 'Download',
				'U_DOWNLOAD_MOD' => ($mod_rows[$i]['mod_id'] == 1) ? '<a href="' . append_sid("admin_download_phpbb.$phpEx") . '" target="main">' : '<a href="' . $mod_rows[$i]['mod_download_loc'] . '" target="_blank">',
				'L_LATEST_VERSION' => $mod_rows[$i]['mod_new_version'],
				'L_CURRENT_VERSION' => $mod_rows[$i]['mod_current_version'],
				'F_COLOR' => $fcolor,
				'L_RECHECK_V' => $lang['btn_Recheck_V'],
				'S_HIDDEN_VID' => $s_hidden_vid)
				);
		}
		$template->pparse("body");
	break;
}

//
// Now let's just close the document properly.
//
include('./page_footer_admin.'.$phpEx);

?>