<?php
/***************************************************************************
 *                          admin_version_config.php
 *                            -------------------
 *   begin                : April 24, 2005
 *   author               : Fountain of Apples < webmacster87@gmail.com >
 *   author, secondary    : DemonBob < dustin.coates@systemoverload.net >
 *
 *   Revision: 0.1.0 -- 11/10/2005
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

//
// Let the ACP know this file exists
//
define('IN_PHPBB', 1);

if( !empty($setmodules) )
{
	$file = basename(__FILE__);
    $module['AVC_AVersioncheck']['Configuration'] = $file;
	return;
}

//
// Load the default header
//
$no_page_header = FALSE;
$phpbb_root_path = "./../";
require($phpbb_root_path . 'extension.inc');
require('./pagestart.' . $phpEx);
// Some AVC specific includes
include($phpbb_root_path . 'includes/functions_avc.' . $phpEx);
include($phpbb_root_path . 'includes/constants_avc.' . $phpEx);
include($phpbb_root_path . 'language/lang_' . $board_config['default_lang'] . '/lang_avc.' . $phpEx);

// 
// Check for the userlevel
// 
if( !$userdata['session_logged_in'] ) 
{ 
    redirect(append_sid("login.$phpEx?redirect=admin/admin_tag.$phpEx", true)); 
} 

//
// Pull all config data
//
$sql = "SELECT *
	FROM " . VERSION_CONFIG_TABLE;
if(!$result = $db->sql_query($sql))
{
	message_die(CRITICAL_ERROR, $lang['No_Config_Info'], "", __LINE__, __FILE__, $sql);
}
else
{
	while( $row = $db->sql_fetchrow($result) )
	{
		$config_name = $row['config_name'];
		$config_value = $row['config_value'];
		$default_config[$config_name] = isset($HTTP_POST_VARS['submit']) ? str_replace("'", "\'", $config_value) : $config_value;
		
		$new[$config_name] = ( isset($HTTP_POST_VARS[$config_name]) ) ? $HTTP_POST_VARS[$config_name] : $default_config[$config_name];

		if ($config_name == 'cookie_name')
		{
			$cookie_name = str_replace('.', '_', $new['cookie_name']);
		}

		if( isset($HTTP_POST_VARS['submit']) )
		{
			$sql = "UPDATE " . VERSION_CONFIG_TABLE . " SET
				config_value = '" . str_replace("\'", "''", $new[$config_name]) . "'
				WHERE config_name = '$config_name'";
			if( !$db->sql_query($sql) )
			{
				message_die(GENERAL_ERROR, sprintf($lang['Update_failed'], $config_name), "", __LINE__, __FILE__, $sql);
			}
		}
	}

	if( isset($HTTP_POST_VARS['submit']) )
	{
		$message = $lang['Config_updated'] . "<br /><br />" . sprintf($lang['Click_return_config'], "<a href=\"" . append_sid("admin_version_config.$phpEx") . "\">", "</a>") . "<br /><br />" . sprintf($lang['Click_return_admin_index'], "<a href=\"" . append_sid("index.$phpEx?pane=right") . "\">", "</a>");

		message_die(GENERAL_MESSAGE, $message);
	}
}



$index_on_yes = ( $new['index_avc'] ) ? "checked=\"checked\"" : "";
$index_on_no = ( !$new['index_avc'] ) ? "checked=\"checked\"" : "";

$check_time_select = avc_select($new['check_time'], 'check_time');


$template->set_filenames(array(
	"body" => "admin/version_config.tpl")
);

//
// Escape any quotes in the site description for proper display in the text
// box on the admin page 
//

$template->assign_vars(array(
	"S_CONFIG_ACTION" => append_sid("admin_version_config.$phpEx"),

	"L_YES" => $lang['Yes'],
	"L_NO" => $lang['No'],
	
	"L_VERSION_CONFIG" => $lang['lbl_Version_Config'],
	"L_VERSION_CONFIG_EXPLAIN" => $lang['Version_Config_explain'],
	"L_ALLOW_INDEX" => $lang['lbl_Allow_Index'],
	"L_ALLOW_INDEX_EXPLAIN" => $lang['Allow_Index_explain'],
	"L_VERSION_CHECK_TIME" => $lang['lbl_Version_Check_Time'],
	"L_VERSION_CHECK_TIME_EXPLAIN" => $lang['Version_Check_Time_explain'],
	"L_SUBMIT" => $lang['Submit'], 
	"L_RESET" => $lang['Reset'], 
	
	"CHECK_TIME_SELECT" => $check_time_select,
	"INDEX_AVC_YES" => $index_on_yes,
	"INDEX_AVC_NO" => $index_on_no)
);

//
// Now let's just close the document properly.
//
$template->pparse("body");

include('./page_footer_admin.'.$phpEx);

?>