<?php
/***************************************************************************
 *                          admin_version_manage.php
 *                            -------------------
 *   begin                : April 15, 2005
 *   author               : Fountain of Apples < webmacster87@gmail.com >
 *   author, secondary    : DemonBob < dustin.coates@systemoverload.net >
 *
 *   Revision: 0.1.0 -- 11/10/2005
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

//
// Let the ACP know this file exists
//
define('IN_PHPBB', 1); 

if( !empty($setmodules) ) 
{ 
    $file = basename(__FILE__); 
    $module['AVC_AVersioncheck']['Enable_Disable'] = $file;
    return; 
}

// 
// Load the default header 
// 
$no_page_header = FALSE; 
$phpbb_root_path = './../'; 
require($phpbb_root_path . 'extension.inc'); 
require('./pagestart.' . $phpEx);
// Some AVC specific includes
include($phpbb_root_path . 'includes/functions_avc.' . $phpEx);
include($phpbb_root_path . 'includes/constants_avc.' . $phpEx);
include($phpbb_root_path . 'language/lang_' . $board_config['default_lang'] . '/lang_avc.' . $phpEx);

// 
// Check for the userlevel
// 
if( !$userdata['session_logged_in'] ) 
{ 
    redirect(append_sid("login.$phpEx?redirect=admin/admin_tag.$phpEx", true)); 
} 

if( $userdata['user_level'] != ADMIN ) { message_die(GENERAL_MESSAGE, $lang['Not_Authorised']); } 

//
// Now let's get into the meat of the matter
//
if ( isset($HTTP_POST_VARS['mode']) || isset($HTTP_GET_VARS['mode']) )
{
	$mode = ( isset($HTTP_POST_VARS['mode']) ) ? $HTTP_POST_VARS['mode'] : $HTTP_GET_VARS['mode'];
	$mode = htmlspecialchars($mode);
}
else
{
	$mode = '';
}

if ( isset($HTTP_POST_VARS['vid']) || isset($HTTP_GET_VARS['vid']) )
{
	$vid = ( isset($HTTP_POST_VARS['vid']) ) ? $HTTP_POST_VARS['vid'] : $HTTP_GET_VARS['vid'];
	$vid = intval($vid);
}
else
{
	$vid = '';
}

	
$template->set_filenames(array(
	"body" => "admin/version_manage.tpl")
);

//
// Is checker enabled or disabled?
//
switch($mode)
{

	case $lang['btn_Check']:
		$new_status = 1;
		$sql = "UPDATE " . VERSION_CHECK_TABLE . "
				SET mod_status = $new_status
				WHERE mod_id = $vid";
		if ( !$db->sql_query($sql) )
		{
			message_die(GENERAL_ERROR, $lang['Status_no_Update'], '', __LINE__, __FILE__, $sql);
		}
		$message = $lang['lbl_Status_Updated'] . "<br /><br />" . sprintf($lang['Click_return_versionmanage'], "<a href=\"" . append_sid("admin_version_manage.$phpEx") . "\">", "</a>") . "<br /><br />" . sprintf($lang['Click_return_admin_index'], "<a href=\"" . append_sid("index.$phpEx?pane=right") . "\">", "</a>");

		message_die(GENERAL_MESSAGE, $message);
	break;
	
	case $lang['btn_Ignore']:
		$new_status = 0;
		$sql = "UPDATE " . VERSION_CHECK_TABLE . "
				SET mod_status = $new_status
				WHERE mod_id = $vid";
		if ( !$db->sql_query($sql) )
		{
			message_die(GENERAL_ERROR, $lang['Status_no_Update'], '', __LINE__, __FILE__, $sql);
		}
		$message = $lang['lbl_Status_Updated'] . "<br /><br />" . sprintf($lang['Click_return_versionmanage'], "<a href=\"" . append_sid("admin_version_manage.$phpEx") . "\">", "</a>") . "<br /><br />" . sprintf($lang['Click_return_admin_index'], "<a href=\"" . append_sid("index.$phpEx?pane=right") . "\">", "</a>");

		message_die(GENERAL_MESSAGE, $message);
	break;
	
	default:
	
		$template->assign_vars(array(
			'L_VERSION_MANAGER'	=> $lang['lbl_Version_Manager'],
			'L_VERSION_MANAGER_EXPLAIN' => $lang['Version_Manager_explain'],
			'L_IGNORE' => $lang['btn_Ignore'],
			'L_CHECK' => $lang['btn_Check'],
	        'S_VERSION_ACTION' => append_sid("admin_version_manage.$phpEx"))
		);
		
		$template->assign_block_vars('switch_version_manage_view', array());
		
		
		$sql = "SELECT mod_id, mod_name, mod_status
				FROM " . VERSION_CHECK_TABLE . " WHERE mod_id > 0
				ORDER BY mod_id";
	
		if( !$q_mod = $db->sql_query($sql) )
		{
			message_die(GENERAL_ERROR, $lang['No_Version'], "", __LINE__, __FILE__, $sql);
		}

		if( $total_mods = $db->sql_numrows($q_mod) )
		{
			$mod_rows = $db->sql_fetchrowset($q_mod);
	
			if(!$q_mod = $db->sql_query($sql))
			{
				message_die(GENERAL_ERROR, "Could not query Version information", "", __LINE__, __FILE__, $sql);
			}
		}
	
		for($i=0;$i < $total_mods;$i++)
		{
			$mod_name = $mod_rows[$i]['mod_name'];
		
			if($mod_rows[$i]['mod_status'] == 1)
			{
				$ignore_button = '<input type="submit" name="mode" value="' . $lang['btn_Ignore'] . '" class="mainoption" />';
			}
			elseif($mod_rows[$i]['mod_status'] == 0)
			{
				$ignore_button = '<input type="submit" name="mode" value="' . $lang['btn_Check'] .'" class="mainoption" />';
			}
			
			$s_hidden_vid = '<input type="hidden" name="vid" value="'. $mod_rows[$i]['mod_id'] .'" />';
			
			$template->assign_block_vars('switch_version_manage_view.switch_version_manage_mod_row', array(
				'L_MOD_NAME' => $mod_rows[$i]['mod_name'],
				'BUTTON_ON' => $ignore_button,
				'S_HIDDEN_VID' => $s_hidden_vid)
			);
		}
	
		$template->pparse("body");
		
	break;


}

//
// Now let's just close the document properly.
//
include('./page_footer_admin.'.$phpEx);
?>