<?php

/**
 * album_hierarchy_functions.php
 *                                   -------------------
 *          begin                : Friday, January 23, 2004
 *          copyright            : (C) 2004 IdleVoid
 *          email                : idlevoid@mail.dk
 *          version              : 1.0.5
 */

/**
 * This program is free software; you can redistribute it and/or modify
 *          it under the terms of the GNU General Public License as published by
 *          the Free Software Foundation; either version 2 of the License, or
 *          (at your option) any later version.
 */
 
// $album_tree : structur description
// indexes :
// - id  : the category id infact : ie Root, 1, 20, 12 and so on
// - idx : rank order
// $album_tree['keys'][id]			=> idx,
// $album_tree['sub'][id]			=> array of sub-level ids,
// $album_tree['parent'][idx]		=> parent id,
// $album_tree['id'][idx]			=> value of the row id : cat_id for cats
// $album_tree['data'][idx]		    => db table row,
// --------------------------------------------------------------------------------------------------

// idea to new table layour for sub categories in personal gallery : 
// ALTER TABLE `phpbb_album_cat` ADD `cat_user_cat_id` MEDIUMINT( 8 ) UNSIGNED DEFAULT '0';

// check wether this is a album addon with the Super Charged Pack by CLowN
// this id done by looking at a define the CLowN uses for his mod
if (defined('ALBUM_SP_CONFIG_TABLE')) 
{
   define(ALBUM_HIERARCHY_COMMON_INCLUDE_FILE,'album_hierarchy_sp.' . $phpEx);
}
else // if it's npot then include this file instead 
{
   define(ALBUM_HIERARCHY_COMMON_INCLUDE_FILE,'album_hierarchy_non_sp.' . $phpEx);
}

// now include the correct version of the file....
include ($album_root_path . ALBUM_HIERARCHY_COMMON_INCLUDE_FILE);

/* debug helper function */
function album_dump_array($data_array, $use_print = true) {
	echo "<Pre>";
    if ($use_print == true) {
        print_r($data_array);
    } else {
        var_dump($data_array);
    } 
	echo "</Pre>";	
} 

/********************** the next two functions ARE related to administration of the categories *************************/

function album_display_admin_index($cur = 'Root', $level = 0, $max_level = -1, $column_offset=1) 
{
    global $template, $phpEx, $lang, $images, $album_tree;
	 
    // display 'the' level
    $this = isset($album_tree['keys'][$cur]) ? $album_tree['keys'][$cur] : -1; 

    // root level
    if ($this == -1)
	{
		$level = -1; 
    
	    // the the maximum level of categories,counting from the root category
		// this is used in the indentation of the categories
        $keys = array();  
	    $max_level = album_get_max_depth($cur, true, $keys);

		$template->assign_vars(array(
			'L_ALBUM_TITLE' => $lang['Category_Title'],
			'L_ALBUM_ACTION' => $lang['Album_Categories_Title'],
			//'HEADER_INC_SPAN' => $max_level - ($level + $column_offset) + 1,
			'HEADER_INC_SPAN' => $max_level + 1,			
			'INC_SPAN_ALL' => $max_level + 4
			)
		);

		$template->assign_block_vars('switch_board_footer', array());
	}
	
    // if we are above the 'root' level, thenadd it to the template (root level is -1)
    if ($this > -1) 
	{
		// display a cat row
         $cat = $album_tree['data'][$this];
         $cat_id = $album_tree['id'][$this];
		 
         // get the class colors
         $class_catLeft = "cat";
         $class_catMiddle = "cat";
         $class_catRight = "cat";
         
		 // get category title
		 $cat_title = $cat['cat_title'];
         $cat_title_trad = album_get_object_lang($cat_id, 'name');

		 if ($cat_title != $cat_title_trad)
             $cat_title = '(' . $cat_title . ') ' . $cat_title_trad; 

		// send to template
        $template->assign_block_vars('catrow', array());
        $template->assign_block_vars('catrow.cathead', array(
				'CAT_ID' => $cat_id,
				'CAT_TITLE' => $cat_title,
				
				'CLASS_CATLEFT' => $class_catLeft,
				'CLASS_CATMIDDLE' => $class_catMiddle,
				'CLASS_CATRIGHT' => $class_catRight,
				'INC_SPAN' => $max_level - $level +1 , // + $column_offset,
				'WIDTH' => ($max_level == $level) ? 'width="50%"' : '',
				
				'U_CAT_EDIT' => append_sid("admin_album_cat.$phpEx?action=edit&amp;cat_id=$cat_id"),
				'U_CAT_DELETE' => append_sid("admin_album_cat.$phpEx?action=delete&amp;cat_id=$cat_id"),
				'U_CAT_MOVE_UP' => append_sid("admin_album_cat.$phpEx?action=move&amp;move=-15&amp;cat_id=$cat_id"),
				'U_CAT_MOVE_DOWN' => append_sid("admin_album_cat.$phpEx?action=move&amp;move=15&amp;cat_id=$cat_id"),
				'U_VIEWCAT' => append_sid("admin_album_cat.$phpEx?action=edit&cat_id=$cat_id")
			)
		); 
         
		// add expandsion of the row height in order to have room for the description
		$rowspan = empty($cat['cat_desc']) ? 1 : 2;

		// creta a table data for each lavel down tot the level where the title (and maybe description) is
		// in other words put 'X' times '<td class="row2" rowspan="1" width="46">&nbsp;</td>' string in 
		// or incase there is a desciption use this text '<td class="row2" rowspan="2" width="46">&nbsp;'1'</td>' instead
		for ($k = 1; $k <= $level; $k++)
			$template->assign_block_vars('catrow.cathead.inc', array('ROWSPAN' => $rowspan));
		
		// send the category description to template... if its specified
		if (!empty($cat['cat_desc'])) 
		{
			$cat_desc = $cat['cat_desc'];
			$cat_desc_trad = album_get_object_lang($cat_id, 'desc');
		
			if ($cat_desc != $cat_desc_trad)
				$cat_desc = '(' . $cat_desc . ') ' . $cat_desc_trad;
		
			$template->assign_block_vars('catrow', array());
			$template->assign_block_vars('catrow.cattitle', array(
				'CAT_DESCRIPTION' => $cat_desc,
				'INC_SPAN_ALL' => $max_level - $level + 4
				)
			);
		} 			
	} // if we are above the root level 
	 
    // display the sub-level
    for ($i = 0; $i < count($album_tree['sub'][$cur]); $i++)
		$column_offset = album_display_admin_index($album_tree['sub'][$cur][$i], $level + 1, $max_level, $column_offset);
	
	// if we are 'above' the root level then add the add category 'footer'
	if ($this > -1) 
	{
		// cat footer, add the footer
		$template->assign_block_vars('catrow', array());
		$template->assign_block_vars('catrow.catfoot', array(
			'S_ADD_CAT_SUBMIT' => "addcategory[$cat_id]",
			'S_ADD_NAME' => "name[$cat_id]",
			'INC_SPAN' => $max_level - $level + 1,
			'INC_SPAN_ALL' => $max_level - $level + 4
			)
		);
	} 
	
	// add indentation to the display
	for ($k = 1; $k <= $level; $k++)
		$template->assign_block_vars('catrow.catfoot.inc', array()); 
	
	// at the moment is isn't used, so it might be removed, but not until 
	// this patch has been approved by other ppl then me.
	return $column_offset; 
} 

// move the tree up or down in the category order
function album_move_tree($cat_id, $move)
{
	global $db, $album_tree;

	// if the album_tree is NOT filled then reload the data
	// this will ensure that the album IS populated with data
	if ( count($album_tree['data']) == 0) {
		album_read_tree();
	}
	
	// 'search' the object
	$this = (isset($album_tree['keys'][$cat_id])) ? $album_tree['keys'][$cat_id] : -1;

	// get the root or parent cat id
	$parent = ($this < 0) ? 'Root' : $album_tree['parent'][$this];

	// renum objects of the same level and regenerate all
	$order = 0;
	$cats = array();
	$parents = array();
	
	// for the nuber of rows read/categories do this loop
	for ($i=0; $i < count($album_tree['data']); $i++) 
	{
		// if the current itetorated parent id is equal to the selected category's parent id then
		// reorder the cat_order, the way that, if the found category is the selected category
		// then move the category by the sequentual order number + 'move direction value'
		// else give it the sequentual order number...this will ensure that the selected category
		// always is moved up or down compared to its siblings
		if ($album_tree['parent'][$i] == $parent)
		{
			$order = $order + 10;
			$norder = ($i == $this) ? $order + $move : $order;
			$album_tree['data'][$i]['cat_order'] = $norder;
		}
		
		// fill these arrays which are going to be need in building the tree (see album_read_tree for similiar code)
		$idx = count($cats);
		$cats[$idx] = $album_tree['data'][$i];
		$parents[ $album_tree['parent'][$i] ][] = $idx;
	}

	// rebuild the tree
	$album_tree = array();
	//function album_build_tree(&$cats, &$parents, $level = -1, $parent = 'Root')
	album_build_tree($cats, $parents);

	// re-order all categories...in the database acording to the album_tree
	// is really the same things as the reorder_cat in admin/album_cat.php
	$order = 0;
	for ($i=0; $i < count($album_tree['data']); $i++)
	{
		$order = $order + 10;
		$sql = "UPDATE " . ALBUM_CAT_TABLE . " SET cat_order=$order WHERE cat_id=" . $album_tree['id'][$i];
		
		if ( !$db->sql_query($sql) ) 
			message_die(GENERAL_ERROR, 'Couldn\'t update album category order', '', __LINE__, __FILE__, $sql);
	}
}

/********************** the next functions are NOT related to administration of the categories *************************/

function album_build_tree(&$cats, &$parents, $level = -1, $parent = 'Root') {
    global $db, $album_tree;
    $album_tree_level = array(); 
	
    // add the categories of this level
    for ($i = 0; $i < count($parents[$parent]); $i++) {
        $idx = $parents[$parent][$i];
        $album_tree_level['id'][] = $cats[$idx]['cat_id'];
        $album_tree_level['sort'][] = $cats[$idx]['cat_order'];
        $album_tree_level['data'][] = $cats[$idx];
    } 
	
    // sort both
    if (!empty($album_tree_level['data']))
        array_multisort($album_tree_level['sort'], $album_tree_level['id'], $album_tree_level['data']); 
 
    // add the tree_level to the tree
    $level++;
    $order = 0;
    for ($i = 0; $i < count($album_tree_level['data']); $i++) 
	{
        $this = count($album_tree['data']);
        $key = $album_tree_level['id'][$i];
        $order = $order + 10;
        $album_tree['keys'][$key]     = $this;
        $album_tree['parent'][]       = $parent;
        $album_tree['id'][]           = $album_tree_level['id'][$i];
        $album_tree['data'][]         = $album_tree_level['data'][$i];
        $album_tree['sub'][$parent][] = $key; 

        // add sub levels
        album_build_tree($cats, $parents, $level, $key);
    } 

    return;
} 

function album_read_tree($cur = 'Root', $can_view = 1, $can_upload = 0, $can_rate = 0, $can_comment = 0, $can_edit = 0, $can_delete = 0) 
{
    global $db, $album_tree; 
	
	if ( count($album_tree['data']) > 0) {
	    return;
	}
    
	// parent categories
    $parents = array(); 
    
	// read categories
    $cats = array();
	
    $sql = "SELECT c.*, COUNT(p.pic_id) AS count
			FROM " . ALBUM_CAT_TABLE . " AS c
				LEFT JOIN " . ALBUM_TABLE . " AS p ON c.cat_id = p.pic_cat_id
			WHERE cat_id <> 0
			GROUP BY cat_id
			ORDER BY cat_order ASC";
			
    if (!$result = $db->sql_query($sql))
        message_die(GENERAL_ERROR, "Couldn't access list of Album Categories", "", __LINE__, __FILE__, $sql);

    if ($db->sql_numrows($result) == 0)
        return;
		
    while ($row = $db->sql_fetchrow($result)) 
	{
        // check if current user has access to the categori after the desired ass
        // album_user_access($cat_id, $passed_auth = 0, $view_check, $upload_check, $rate_check, $comment_check, $edit_check, $delete_check)
        $album_user_access = album_user_access($row['cat_id'], $row, $can_view, $can_upload, $can_rate, $can_comment, $can_edit, $can_delete); 
		
		// does the user full fill the access/security criteria ?
		if ( ($album_user_access['view'] >= $can_view)       && 
			 ($album_user_access['upload'] >= $can_upload)   &&
			 ($album_user_access['rate'] >= $can_rate)       &&
			 ($album_user_access['comment'] >= $can_comment) &&
			 ($album_user_access['edit'] >= $can_edit)       &&
			 ($album_user_access['delete'] >= $can_delete)    )
		{
            // if current category id is the same as the parent id, then replace parent id with 0
            if ($row['cat_parent'] == $row['cat_id'])
                $row['cat_parent'] = 0; 
				
            // store the parent id for this category in the row array
            $row['parent'] = ($row['cat_parent'] == 0) ? 'Root' : $row['cat_parent'];
            $idx = count($cats);
            $cats[$idx] = $row;
            $parents[$row['parent']][] = $idx;
        } 
    } 
    // build the tree
    $album_tree = array();
    album_build_tree($cats, $parents);

    return $cats;
} 

function album_get_object_lang($cur, $field, $deleting = false) 
{
    global $lang, $album_tree;
	
    $res = '';
    $this = $album_tree['keys'][$cur];

    if ($cur == 'Root') 
	{
		if ($deleting)
        	$res = $lang['Delete_all_pics'];
		else
			$res = $lang['Public_Categories'];
    } 
	else 
	{
        switch ($field) 
		{
            case 'name':
                $field = 'cat_title';
                break;
            case 'desc':
                $field = 'cat_desc';
                break;
        } 
        $res = $album_tree['data'][$this][$field];
        if (isset($lang[$res])) $res = $lang[$res];
    } 
    return $res;
} 

function album_get_tree_option($cur = '', $all = false, $deleting = false, $include_root = true) 
{
    global $album_tree, $lang;
    
	$keys = array();
    $keys = album_get_auth_keys('Root', $all);
    $res = '';
    
	for ($i = 0; $i < count($keys['id']); $i++) 
	{
        /* should we include the 'Root' cate id, or substitude it with a -1 ? */
        $cat_id = ($keys['id'][$i] == 'Root' && $include_root == false) ? -1 : $keys['id'][$i];
		
        $selected = ($cur == $cat_id) ? ' selected="selected"' : '';
        $res .= '<option value="' . $cat_id . '"' . $selected . '>'; 
		
        // name
        $name = album_get_object_lang($keys['id'][$i], 'name', $deleting);
		
		// increment        
		$inc = '';
        for ($k = 1; $k <= $keys['real_level'][$i]; $k++) 
		{
            $inc .= '|&nbsp;&nbsp;&nbsp;';
        } 

        if ($keys['level'][$i] >= 0)
            $inc .= '|--';
		
        $name = $inc . $name;
        $res .= $name . '</option>';
    } 
    return $res;
} 

function album_get_auth_keys($cur = 'Root', $all = false, $level = -1, $max = -1) 
{
    global $album_tree;
    $keys = array();
    $last_i = -1; 
    
	// add the level
    if (($cur != 'Root') && $all == false)
        return $keys; 
    
	// push the level
    if (($max < 0) || ($level < $max) || (($level == $max) && ($album_tree['parent'][$album_tree['keys'][$cur]] == 'Root'))) 
	{
        // if child of cat, align the level on the parent one
        $orig_level = $level;
        
		// store this level
        $last_i++;
        $keys['keys'][$cur] = $last_i;
        $keys['id'][$last_i] = $cur;
        $keys['real_level'][$last_i] = $orig_level;
        $keys['level'][$last_i] = $level;
        $keys['idx'][$last_i] = (isset($album_tree['keys'][$cur]) ? $album_tree['keys'][$cur] : -1); 
		
        // get sub-levels
        for ($i = 0; $i < count($album_tree['sub'][$cur]); $i++) 
		{
            $tkeys = array();
            $tkeys = album_get_auth_keys($album_tree['sub'][$cur][$i], $all, $orig_level + 1); 
            // add sub-levels
            for ($j = 0; $j < count($tkeys['id']); $j++) 
			{
                $last_i++;
                $keys['keys'][$tkeys['id'][$j]] = $last_i;
                $keys['id'][$last_i] = $tkeys['id'][$j];
                $keys['real_level'][$last_i] = $tkeys['real_level'][$j];
                $keys['level'][$last_i] = $tkeys['level'][$j];
                $keys['idx'][$last_i] = $tkeys['idx'][$j];
            } // for( $j = 0.....
        } // for($i = 0.....		
    } // if (($max < 0 .....
    return $keys;
} 

function album_get_max_depth($cur = 'Root', $all = false, &$keys) 
{
	$max_level = 0;
	
	// if keys aren't set, then get them from the album_tree
    if (empty($keys['id'])) 
	{
        $keys = array();
        $keys = album_get_auth_keys($cur, $all);
    } 
    
	// loop through the keya to find the maximum level.. aka max level
	for ($i = 0; $i < count($keys['id']); $i++) 
	{
        if ($keys['level'][$i] > $max_level) 
		{
            $max_level = $keys['level'][$i];
        } 
    } 
    return $max_level;
}

// create the navigation tree at the top of the page..like : fortum title -> categori -> forum....
function album_make_nav_tree($cur, $pgm = '', $nav_class = 'nav') 
{
    global $phpEx, $db, $album_tree; 
    // get topic or post level
    $type = substr($cur, 0, 1);
    $id = intval(substr($cur, 1));
    $topic_title = '';
    $fcur = ''; 

    // keep the compliancy with prec versions
    if (!isset($album_tree['keys'][$cur]))
        $cur = isset($album_tree['keys'][$cur]) ? $cur : $cur; 

    // find the object
    $this = isset($album_tree['keys'][$cur]) ? $album_tree['keys'][$cur] : -1;
    $res = '';
	
    while (($this >= 0) || ($fcur != '')) 
	{
        $field_name = album_get_object_lang($cur, 'name');
        $param_type = 'cat_id';
        $param_value = $album_tree['id'][$this];
        $pgm_name = "album_cat.$phpEx";
		
        if ($pgm != '') 
			$pgm_name = "$pgm.$phpEx";

        if (!empty($field_name))
            $res = '<a href="' . append_sid('./' . $pgm_name . (($field_name != '') ? "?$param_type=$param_value" : '')) . '" class="' . $nav_class . '">' . $field_name . '</a>' . (($res != '') ? ALBUM_NAV_ARROW . $res : ''); 

        // find parent object
        if ($fcur != '') 
		{
            $cur = $fcur;
            $pgm = '';
            $fcur = '';
            $topic_title = '';
        } 
		else 
		{
            $cur = $album_tree['parent'][$this];
        } 
        $this = isset($album_tree['keys'][$cur]) ? $album_tree['keys'][$cur] : -1;
    } // while
    return $res;
}

// get moderator information for the given category
function album_get_moderator_info($cat) {
    global $phpEx, $lang, $db;

    /* Most of this code is copyrighted by Smartor */
    /* Modifications are done by IdleVoid */
    $moderators = '';
    $grouprows = array();

    // We have usergroup_ID, now we need usergroup name
    $sql = "SELECT group_id, group_name
			FROM " . GROUPS_TABLE . "
			WHERE group_single_user <> 1
				AND group_type <> " . GROUP_HIDDEN . "
				AND group_id IN (" . $cat['cat_moderator_groups'] . ")
			ORDER BY group_name ASC";
				
	if (!$result = $db->sql_query($sql)) {
		message_die(GENERAL_ERROR, 'Could not obtain usergroups data', '', __LINE__, __FILE__, $sql);
	} 
		
	while ($row = $db->sql_fetchrow($result)) {
		$grouprows[] = $row;
	} 
    	
	if (count($grouprows) > 0) {
		for ($j = 0; $j < count($grouprows); $j++) {
        	$group_link = '<a href="' . append_sid("groupcp.$phpEx?" . POST_GROUPS_URL . '=' . $grouprows[$j]['group_id']) . '">' . $grouprows[$j]['group_name'] . '</a>';
            $moderators .= ($moderators == '') ? $group_link : ', ' . $group_link;
        } 
    } 
	
    return $moderators;
} 

// returns all the category id for current catgory and it subs
function album_get_sub_cat_ids($cur = 'Root', &$cats) 
{
    global $db, $album_tree; 

	// get all the  sub categori id for current sub category
	for ($j=0; $j < count($album_tree['sub'][$cur]); $j++) 
	{
		$wcur = $album_tree['sub'][$cur][$j];
        $wthis = $album_tree['keys'][$wcur];
        $wdata = $album_tree['data'][$wthis];

		// add the 	category id
	    $cats[] = $wdata['cat_id'];
	}
	
	// do this for each sub category... recursive
	for ($i=0; $i < count($album_tree['sub'][$cur]); $i++)
		album_get_sub_cat_ids($album_tree['sub'][$cur][$i], &$cats);
}

function album_get_comment_count($cat)
{
	global $db;
	
	if (is_array($cat)) {
	    $where_clause = " WHERE pic_cat_id IN (". implode(",", $cat) .")";
	} else {
		$where_clause = " WHERE pic_cat_id = '" . $cat  ."'";
	}
	
	$sql = "SELECT COUNT(comment_id) AS comment_count
			FROM " . ALBUM_COMMENT_TABLE . " 
			LEFT JOIN " . ALBUM_TABLE . " ON comment_pic_id = pic_id " . $where_clause;

	if (!$result = $db->sql_query($sql)) 
	{
        message_die(GENERAL_ERROR, 'Could not get category comment count information', '', __LINE__, __FILE__, $sql);
    } 
    $comment_row = $db->sql_fetchrow($result); 
	
	return intval($comment_row['comment_count']);
}


function album_get_total_pics($cats)
{
	global $db;
	
	$categories = implode(",", $cats);
	
	$sql = "SELECT COUNT(p.pic_id) AS count
			FROM " . ALBUM_CAT_TABLE . " AS c
				LEFT JOIN " . ALBUM_TABLE . " AS p ON c.cat_id = p.pic_cat_id
			WHERE cat_id in (" . $categories .")";
	
	if (!$result = $db->sql_query($sql))
        message_die(GENERAL_ERROR, "Couldn't get total number of pictures for album categories and sub categories", "", __LINE__, __FILE__, $sql);

    if ($db->sql_numrows($result) == 0)
        return 0;
	
	$row = $db->sql_fetchrow($result);
	
	return intval($row['count']);
}


function album_display_index($cur = 'Root', $show_header = false, $show_public_footer = false) {
    global $board_config, $template; 
    // let's dump all of this on the template
    $keys = array();
    $display = album_build_index($cur, -1, -1, $keys, $show_header, $show_public_footer);

    if ($display)
        $template->assign_var_from_handle('ALBUM_BOARD_INDEX', 'album');

    return $display;
} 
?>
