<?php
/*-----------------------------------------------------------------------------
            ADMIN UPLOAD UTILITY - SMILIES MODULE - A phpBB Add-On
  ----------------------------------------------------------------------------
    Please read the file README.TXT for licensing and copyright information.
  ----------------------------------------------------------------------------
    module_smilies.php - Smilies Module File
    File Version: 2.1.0
    Begun: August 19, 2004
    Last Modified: Monday, December 06, 2004
-----------------------------------------------------------------------------*/

if ( !defined('IN_PHPBB') )
{
	die('Hacking attempt');
}

if( !empty($setmodules) )
{
	$module['General'][' '] = $filename . '?type=smilies';
	return;
}

/*  Function: boolean auto_add_object( string $new_filename )
	Adds an entry with information about an uploaded file to the forum's
	database.  Entries for smilies must have unique code, like :happy:, so a
	check is made for an existing entry before attempting to add.

	$new_filename - Contains the filename created for an uploaded file on
						the server, including the extension but excluding the
						path. This might be happy.gif, but not
						smilies/happy.gif.

	Returns TRUE on successfully adding an entry.
	Returns FALSE on failure to check for an existing entry, successfully
	finding an existing entry, or failure to add a new entry.
*/
function auto_add_object($new_filename)
{
	global $db, $auu, $gen;

	// First, build the code and emotion for the new smiley
	$smilies_name = explode('.', $new_filename);
	$name_count = count($smilies_name);
	$code = '';
	$emotion = '';
	if( $name_count > 2 )
	{
		for($ii=0; $ii<$name_count-1; $ii++)
		{
			$code .= $smilies_name[$ii];
			$emotion .= $smilies_name[$ii] . ' ';
		}
	}
	else
	{
		$code = $smilies_name[0];
		$emotion = $smilies_name[0];
	}
	$code = ':' . $code . ':';
	$emotion = ucfirst(trim($emotion));

	// Replace < & > in the code & emotion for HTML purposes
	// $final[0] will be the final code, $final[1] will be the final emotion
	$final = str_replace(array('<', '>'), array('&lt;', '&gt;'), array($code, $emotion));

	// Check for existing smiley with the same code
	$sql = 'SELECT COUNT(*) as total FROM ' . SMILIES_TABLE . ' WHERE code = \'' . str_replace("\'", "''", $final[0]) . '\'';
	$row = array();

	if( !$result = $db->sql_query($sql) )
	{
		// Could not check for an existing entry
		$gen->build_error_msg('CC_FAIL');
		return false;
	}
	$row = $db->sql_fetchrow($result);
	if( $row['total'] )
	{
		// Found an existing entry
		$gen->build_error_msg('CC_FOUND');
		return false;
	}

	// Save the data to the smiley table.
	$sql = 'INSERT INTO ' . SMILIES_TABLE . " (code, smile_url, emoticon)
		VALUES ('" . str_replace("\'", "''", $final[0]) . "', '" . str_replace("\'", "''", $new_filename) . "', '" . str_replace("\'", "''", $auu->cfg['db_path'] . $final[1]) . "')";

	if( !$db->sql_query($sql) )
	{
		return false;
	}

	// If we make it here, then it was added into the database.
	return true;
}

/*  Function: string delete_db_object( string $item )
	Removes an entry for an uploaded file from the forum's database.

	$item - Contains the filename created for a file that has just been
					deleted from the server, including the extension.

	Returns a string.
		If deletion is successful, that string is: 'AUUMODULE_CD_SUCCESSFUL'
		If deletion fails, the string is: 'AUUMODULE_CD_FAIL'
*/
function delete_db_object($item)
{
	global $db, $auu;

	$sql = 'DELETE FROM ' . SMILIES_TABLE . ' WHERE smile_url = \'' . str_replace("\'", "''", $auu->cfg['db_path']  . $item) . '\'';
	$result = $db->sql_query($sql);
	$numrows = $db->sql_affectedrows($sql);
	if( !$result || !$numrows )
	{
		$data = 'AUUMODULE_CD_FAIL';
	}
	else
	{
		$data = 'AUUMODULE_CD_SUCCESSFUL';
	}
	return $data;
}

/*  Function: void assign_module_tpl( void )
	Sets up any template features specific to this module.  There are no major
	features, so a module copyright is the only thing done here.
*/
function assign_module_tpl()
{
	global $auu, $template;

	$template->assign_vars(array(
		'MODULE_COPYRIGHTS' => $auu->cfg['display_name'] . ' Module &copy; 2004 Thoul'
	));
}


/* MODULE SPECIFIC FUNCTIONS FOLLOW */

// Don't need any here.
?>